#include "TestFramework.h"

#include "YamlParser.h"
#include "StringStream.h"

TEST_CASE(TestYamlParser, "core")
{
    const auto content = R"(depends:
  headers: 
    public:
      - core)";

    StringStream stream(content);

    YamlDocuments yaml_docs;
    YamlParser parser;
    const auto status = parser.parse(stream, yaml_docs);
    REQUIRE(status.ok());
}