#pragma once

#include "TestCase.h"

#include "Vector.h"
#include "String.h"

class TestUiApplication;

class TestCaseRunner
{
public:
    TestCaseRunner();

    static TestCaseRunner& getInstance();

    ~TestCaseRunner();

    //TestUiApplication* getTestApplication();

    void addTestCase(const String& label, const String& tag, TestCase::TestCaseFunction func);

    void markTestFailure(const String& line);

    bool run(const Vector<String>& args);

    //void setTestApplication(TestUiApplication* app);
private:

    //TestUiApplication* mTestApplication{ nullptr };
    Vector<String> mFailingTests;
    static bool sLastTestFailed;
    static String sFailureLine;
    Vector<TestCase*> mCases;
};
